Abakt?

Abakt Logo Abakt Manual
Table of Contents | Next: Edit Profile

Abakt?

Abakt is a free, open source, backup tool for Windows.

For a short overview see Introduction.

Features
Filters

Select files or directories by using wildcards, sets and other advanced masks.
Also, you can use these file properties to select files: attributes, size, age and modification date.

Backup (Archive)

Create a standard PKZIP zip archive using the built-in zip library.
Or call the external command line tool 7-Zip to create archives.
You can also copy, move or delete the selected files.

Automation

Abakt accepts command line arguments.
Use the command line options to feed a Task Scheduler, or to write your own batch scripts.

  • Introduction
  • Requirements
  • Setup
  • Donate
  • License

Generated using AurigaDoc


Introduction

Table of Contents | Up: Abakt? | Next: Requirements

Introduction
What you can use Abakt for:

Despite its name and its original intention, Abakt can do a bit more than creating backups:

The purpose of Abakt is to select files to do 'something' with, using Abakt's powerful filtering capabilities.

Select files to do 'something' with...
Select files (using filters)...

  • Select the directories to include on page Source/Directories [F6].

  • Create Filters to specify which files to use.

    Files in unselected (unchecked) directories will be ignored throughout the rest of the filter process.

  • Preview the list of selected files

    Before you execute an Action, take a look at the filelists that Tools / Filter Preview generates. If a file is not in the list you expect it to be, you should review your filter settings.

Do 'Something' with the selected files...

  • Choose the Action you want to perform on the selected files. You can archive, copy, move or delete files.

    Optionally you can tell Abakt how it should deal with the Archive attribute of files. Useful for creating Full, Differential or Incremental backups.

  • Edit the settings for the chosen Action to your liking.

  • Set the Destination.

  • Decide what to do when an Action has finished successfully by setting the Finalize options.

Execute the Profile

  • Click the button 'Execute Profile' in the top right corner of the main window.

  • The Action window will open and display the progress of the current Profile.


Requirements

Table of Contents | Up: Abakt? | Previous: Introduction | Next: Setup

Requirements

Abakt runs on the following operating systems:

  • Windows 95, 98, 98SE, ME, XP (SP1/SP2) or 2003.
  • A Pentium CPU.

Abakt also runs on Unix/Linux using wine [http://www.winehq.org].


Setup

Table of Contents | Up: Abakt? | Previous: Requirements | Next: Donate

Setup
Installation

To install Abakt, execute the setup file and follow the instructions.
You do not have to uninstall previous versions of Abakt before installing.

Uninstallation

Use the uninstaller: 'Control Panel / Add or Remove Programs'.

Uninstalling Abakt removes all files in the installation directory. All the references to Abakt's files will be removed from the registry.

Optional: Files saved in your "home" directory can be removed permanently.


Donations

Table of Contents | Up: Abakt? | Previous: Setup | Next: License

Donations
Abakt is free software

I spend as much time as possible working on Abakt and replying to your questions, suggestions and bug reports.
Consider donating a small amount of money if you use Abakt regularly.

How to make a donation:

See the donation page on Abakt's website: http://www.xs4all.nl/~edienske/abakt/donate.html.

Donations can be made using PayPal. If you do not have a PayPal account, you can make donations using your credit card or bank account where available.


License

Table of Contents | Up: Abakt? | Previous: Donate

License

Abakt is free software, covered by the GNU General Public License.

Where to find the license

The GNU General Public License is included in the installer and can be read on http://www.xs4all.nl/~edienske/abakt/license.html. It is also available as a text file (LICENSE.TXT) in Abakt's source distribution.

More information on Free Software:
  • Wikipedia: GNU General Public License.
  • www.gnu.org
  • www.opensource.org


Edit Profile

Table of Contents | Previous: Abakt? | Next: Tools

Edit Profile

For a quick overview of using Abakt see Introduction.

  • 1 - Source
  • 2 - Filters
  • 3 - Action
    • Action Type
    • Action Type Settings
      • Zip
      • 7-Zip
      • File Operation
    • Destination
  • 4 - Finalize
    • History


1 - Source [F6]

Table of Contents | Up: Edit Profile | Next: 2 - Filters

1 - Source [F6]

Select the directories and files you want to do something with.

Unselected directories will be ignored throughout the rest of the filter-process.

Directories

This panel displays a tree of directories for every root directory.

You can mark a directory to be included or excluded in further operations. New directories (that did not exist when the Profile was created) inherit their parent's selection state.

More useful functions are provided by the 'More' drop-down button. These functions are also accessible by clicking the right mousebutton.

Files

This panel shows all the files (and their properties) in the current directory.

Click a column header or a Filter icon to change the sorting order.

The 'Active FilterSet' column displays the first FilterSet that applies to this file (if any). It may also display 'Directory Not Selected', which is not a FilterSet.

The Filter icons

Abakt uses the following icons to display the filter status:

  • Excluded (yellow X)
    File will be ignored throughout the rest of the filtering process.
  • Included (lightblue square)
    File is selected (and will be included in the backup).
  • Not Compressed (darkblue square):
    File will be included but not compressed.

Click the 'FilterSet' drop-down button to display a menu that helps you to easily define or edit FilterSets. This menu will also appear if you click the right mousebutton.


2 - Filters [F7]

Table of Contents | Up: Edit Profile | Previous: 1 - Source | Next: 3 - Action

2 - Filters [F7]

Edit and create the FilterSets Abakt uses to select files.

Unselected directories will be ignored throughout the rest of the filter-process.

See the section Introduction for a short overview of what to use Abakt for.

FilterSets
What is a FilterSet?

A FilterSet consists of Properties and Conditions:

  • The Properties describe the FilterSet and tell Abakt what it should do when Conditions are met.
  • The Conditions are a group of file-property filters. Every Condition must be met for a FilterSet to be applied.

TIP: If you think a FilterSet is a bit intimidating, you should only use the Path Mask at first.

How does it work?

Abakt uses the following FilterSet-rules to determine if a file should be included or not:

  • Every non-empty Condition must be true for this FilterSet's Action to be applied (logical AND).
  • An empty Condition means the File Property will be ignored.
  • Condition expressions must be separated by a semicolon (;), and will be logically OR'ed.
An example:

The Conditions are logically AND'ed (every condition must be true for the FilterSet's Action to be applied). The Condition expressions (seperated by a semi-colon) will be logically OR'ed.

FilterSet Conditions:

Path = "*.doc"
Size = "<1024; >312k"

Pseudo code:
IF (
    (filename has the extension '.doc')
    AND (
        (filesize is less than 1024 Bytes)
        OR (filesize is greater than 312 kiloBytes) )
) THEN action will be applied
FilterSet - Properties
Name

A name that describes the Action. This can be any text you'd like.

Action

Action can have one of these values:

  • Exclude
    This FilterSet is used to specify files to exclude.
  • Include
    This FilterSet is used to specify files to include, always.
  • No Compression
    Does not influence the filter process, only the compression level for included files.
Enabled

You can switch-off a FilterSet if by unchecking this option.

FilterSet - Conditions
Path (Mask)

Syntax: MASK

Create a MASK to select files by path and/or filename.
A MASK can contain Wildcards, the Pipe character and Sets.
A MASK can contain multiple path masks, separated by a ';' (implemented in Abakt 0.9.5-beta3).

Wildcards: * ?
  • * : A range of characters.
  • ? : Any character.
  • If a mask contains a \ files are matched against the full path of a file (including the drive).

You should use * to select any file, not *.* .

Pipe character: |

Use a pipe character to seperate the directory-part of a filename from the name-part. This allows you to create some advanced filters.

Syntax: directory-mask|filename-mask

Sets: [a-z] [!0-9] [12.ad#$]
  • Each set should be enclosed in brackets: [set].
    Between the brackets are the elements of the set. Each element is a literal character or a range.
  • Ranges are specified by an initial value, a dash (-), and a final value: [a-z].
    Do not use spaces or commas to separate the elements of the set.
  • A set must match a single character in the string. The character matches the set if it is the same as one of the literal characters in the set, or if it is in one of the ranges in the set.
  • A character is in a range if it matches the initial value, the final value, or falls between the two values. All comparisons are case-insensitive.
  • If the first character after the opening bracket of a set is an exclamation point (!), then the set matches any character that is not in the set.
  • Example of a mask with the [ character: *[[]*
    Example of a mask with the ] character: *]*
Example masks:
  • *\temp\*|*
    Selects all files in directories with the name 'temp'.
  • C:\Documents and Settings*\temp\*|*
    Selects all files in directories named 'temp' below 'C:\Documents and Settings'.
  • *part-of-dirname*|*.doc
    Selects all .doc files in directories with names that contain 'part-of-dirname'.
Use ';' to separate multiple path masks (available since 0.9.5-beta3):

Example MASK: *.jpg;*.mpg
This MASK will be treated as two path masks that are logically OR'ed. Which means the FilterSet will be applied if at least one entry is true.

Size (Bytes)

Syntax: [ < <= == != >= > ] VALUE[K|M|G] [;]

VALUE is file size in bytes, and should be a positive number or 0.

Other allowed file size notations are: '1K', '2M' or '3G'. There should be no whitespace between the number and [K|M|G].

Floating point format: '1.23M' is not supported at this time.

Example:

If Action is "Exclude" this Condition: "<1024; >2G" will exclude all files that are less the 1024 bytes or greater than 2 GB.

Date (yyyy-mm-dd)

Syntax: [ < <= == != >= > ] VALUE [;]

VALUE is file modification date, and should be formatted as 'yyyy-mm-dd'.

Age (Days)

Syntax: [ < <= == != >= > ] VALUE [;]

VALUE is file age in days, and should be a positive number or 0.

Attributes (H,R,S)

Syntax: [ == != ] VALUE [;]

VALUE is file attribute(s) as a string made up of the characters H, R, S (case sensitive).
Where H='Hidden', R='Read Only' and S='System'.

If an attribute is not specified, it will be ignored.

Even though it is possible to use the character A, this is not recommended: the Archive bit (A) is dealt with by Abakt when making backups. See Action Type / Archive Mode.

Examples:

Apply Action if attributes R and H are set: '==RH'.
Apply Action if attribute is S not set: '!=S'.

A diagram

This diagram shows a graphic display of Abakt's filter engine:


3 - Action [F8|F9|F10]

Table of Contents | Up: Edit Profile | Previous: 2 - Filters | Next: 4 - Finalize

3 - Action [F8|F9|F10]

Select and specify the type of action Abakt should perform.

  • Action Type
  • Action Type Settings
    • Zip
    • 7-Zip
    • File Operation
  • Destination


3a - Action Type [F8]

Table of Contents | Up: 3 - Action | Next: Action Type Settings

3a - Action Type [F8]
Action Type

Choose between creating an archive or performing a file operation.

See Action Type Settings for more information.

Create Archive
  • Zip
    Use Abakt's built-in zip-library (ZipBuilder) to create an archive.
    See Action Type Settings - Zip.
  • 7-Zip
    Call external 7-Zip command line tool (if installed) to create Zip or 7-Zip archives.
    See Action Type Settings - 7-Zip.
File Operation
  • Copy
    Copy the selected files from Source to Destination.
  • Move
    Move the selected files from Source to Destination.
  • Delete
    Delete the selected files (!).

See Action Type Settings - File Operation.

Archive Mode
How to deal with the Archive attribute (A)?
  • Default
    Use all selected files (ignoring the Archive attribute).
    Don't modify Archive attribute.
  • Full
    Use all selected files (ignoring the Archive attribute).
    Clear Archive attribute after Action.
  • Differential
    Use [A]-files only. (Files with Archive attribute set).
    Don't modify Archive attribute.
  • Incremental
    Use [A]-files only. (Files with Archive attribute set).
    Clear Archive attribute after Action.
  • Inverse
    Use non-[A]-files only. (Files without Archive attribute set).
    Don't modify Archive attribute.
Include Empty Source Directories

Enable this option to include the empty source directories in the destination.
(Not implemented for ActionType 7-Zip yet.)

This option replaces 'Preferences/Advanced/Include Empty Directories' that was used in Abakt 0.9.4 and older releases.

  • Empty directories can not be added to an archive with 'Path Information' set to 'None'.
  • TODO: Implement for '7-Zip'.


3b - Action Type Settings [F9]

Table of Contents | Up: 3 - Action | Previous: Action Type | Next: Destination

3b - Action Type Settings [F9]

Depending on the selected Action Type Abakt automatically displays the appropriate window.

  • Zip
  • 7-Zip
  • File Operation


Zip

Table of Contents | Up: Action Type Settings | Next: 7-Zip

Zip

Action Type 'Zip' uses the built-in zip-library to create archives.

Limitations of a Zip archive created with the built-in zip-library:
  • The total size of the archive is limited to 4 GB.
  • The total number of files in an archive is 65535.
  • Every single file to be added to the archive can not be greater than 2 GB.
Method

Instructs Abakt how to deal with the files in (possibly existing) Zip archives.

  • New
    Creates a new Zip archive that does not overwrite an existing Zip archive with the same filename.
    If a Zip archive with the same filename exists, the new filename will have " (++nr)" appended.
  • Replace
    A new Zip archive will be created, possibly overwriting an existing Zip archive with the same name.
    If a Zip archive with the same filename exists it will be copied to a temporary file. (You can disable behaviour this on the Preferences window.) When the Action has finished succesfully, the temporary copy will be deleted.
  • Update
    Files in an existing Zip archive will be updated with newer files.
    New files (not found in the Zip archive) will be added.
    Files in the Zip archive that do not exist on disk anymore will not be removed from the Zip archive.
  • Freshen
    Files in an existing Zip archive that have newer files on disk will be replaced.
    No new files will be added to this Zip archive.

Choosing 'Update' or 'Freshen' possibly has no effect on a Zip archive's filename that uses a Name Template with dynamic date/time.

Path Information

The path information to store for every file in the Zip archive.

  • Full
    The Source directory (without drive information) will be stored.
  • Relative
    Path information relative to the Source directory will be stored.
    This means that the Source directory is stripped from the Path Information in the archive.
    There could be conflicts if files below two different Source directories (disregarding drive information) share the same path/name combination.
  • None
    No path information at all.
    In other words, the file will be stored in the Zip archive as it is, without path or drive information.
    There could be conflicts if files below the Source directory (disregarding drive information) share the same path/name combination.
Compression

A value between 0 and 9:
0=None; 1=Fast; 6=Normal; 9=Maximum

Password

Abakt stores the password in the Profile (.abp file) as plain text. Be sure your Data/Profiles directory can not be accessed by someone else.

Split (and Span)

The Zip archive can be split into parts. The size of each part is defined by Volume Size.

  • If Volume Size is set to 'Custom', you can modify the size of each part by invoking the Custom Size editor by clicking the '...' button.
  • Every part will have a filename like: '[ProfileName].z##', where ## is a value from 01 to 99.
  • The last part will be called '[ProfileName].zip'.
    This is the file you need to open to restore a backup (using any PKZIP compatible unzipper, or Abakt).
The difference between Spanning and Splitting:
A Spanned Zip archive is split into parts that should be saved on removable media (floppy disks).
A Split Zip archive can be saved anywhere, most likely on fixed disks (harddisks).
Add Comment

Uses the same formatting rules as the Destination Name Template.


7-Zip

Table of Contents | Up: Action Type Settings | Previous: Zip | Next: File Operation

7-Zip

This Action Type uses the filelist generated by Abakt as input for the command line application 7z.exe.

You should download and install 7-Zip yourself.

Tip: You can trick Abakt into using Rar.exe instead of 7z.exe on page Preferences/Action. Rar is not free.

Limitations of archives created with 7-Zip:
  • Zip archives (.zip):
    From the manual: "7-Zip supports Zip64 extension of ZIP format". I think this is done automatically. Using 7-Zip version 4.32 I managed to create zip archives larger than 4 GB without problems.
    These large zip archives can not be extracted with Abakt's built-in zip-library. Use 7-Zip Manager, IZArc or WinZip instead.
  • 7-Zip archives (.7z)
    Practically none.
    See www.7-zip.org for the 7z format details.
Command Line
Preview

The command line parameters that will used when calling the 7-Zip executable.

Template

Lets you build the command line with which 7z.exe will be called.
Use the Variables below to make this an easier task.
Example: "$C $T $N -mx=5 $P $W $L".
Refer to the 7-Zip manual for more information on command line syntax.

Variables

Following are the variables you can use in the Command Line Template.
The variables are case-sensitive.

$C - Command

a=Add; u=Update

$T - Archive Type

7z.exe supports several compression methods. They are passed to 7z.exe using the command line swith -t. Most commonly used are '7z' and 'zip'.
The chosen value also sets the extension for archive (do not enter the leading dot '.').
See 7-Zip's manual for a description of the command line switch -t.

$N - Name

Destination.Directory + Destination.Name

$P - Password

Abakt stores the password in the Profile (.abp file) as plain text. Be sure your Data/Profiles directory can not be accessed by someone else.

$W - Working Directory

This is the Temporary Directory defined in Preferences.

$L - ListFile

Required! Without this variable 7z.exe does not know what files to use.

$$ - $

Use $$ to have a $ in the command line.


File Operation

Table of Contents | Up: Action Type Settings | Previous: 7-Zip

File Operation

Use this Action Type to perform file operations on the selected files.

Methods

You can select the desired method on page Action Type.

  • Copy
    Copies the selected files to the destination directory.
  • Move
    Moves the selected files to the destination directory.
  • Delete
    Deletes the selected files.
    You can use this method to create a Profile that cleans up some directories by removing unnecessary files.
    Be very careful using this operation!
Overwrite Existing Files

Applies to Copy and Move operations.
If enabled, existing destination files will be replaced.

Also Overwrite Read Only Files

Enable this option to overwrite existing Read Only files.

Use Recycle Bin If Possible

Applies to the Delete operation.
Windows can not guarantee that the Recycle Bin will used for delete operations.

Use Windows function SHFileOperation

Obsolete since 0.9.5-beta1.


Destination [F10]

Table of Contents | Up: 3 - Action | Previous: Action Type Settings

Destination [F10]
Directory

Specify the destination directory for the selected Action.

Automatically Create Directory

Enabling this option will automatically create the Destination Directory if it does not exist when you execute an Action.
Ignored for File Operation Delete.

Name
Preview

The destination file or directory.
The actual destination is: 'Directory + Preview'.

Template

Use Template to build the Destination's Name. This is either the name of an archive or the name of a directory when Copy/Move is used.

Special variables (note the mandatory single quotes):
  • '$N'
    Name of the Profile.
  • '$M'
    Archive Mode.
  • '$V'
    Abakt version information (as displayed on the About window).
  • '$$'
    $ character.
  • Format Text strings
    See Format Text for more information.

    • Illegal filename characters will be removed from the resulting string.

Append Extension

If disabled, the default extension for the chosen Action Type will not be added to the destination name.
Only works for Zip Archives. Does not work for Split Zip Archives.


Finalize [F11]

Table of Contents | Up: Edit Profile | Previous: 3 - Action

Finalize [F11]

The operations to perform after an Action has been successfully completed.

History

See Edit History.

FileList

If enabled, a text file containing the list of files successfully operated on will be created and written to the destination directory. This file will have the same name as Destination.Name, with the extension ".txt".

  • Only works for Action Type 'Zip' at this time.
Remove Emptied Source Directories

Enable this option to remove directories that were emptied as a result of Copy/Move/Delete actions.
Directories will be removed after the Action has finished successfully.

  • Only directories that became empty as a result of the Action will be removed. Directories that were empty before the Action started are ignored.
Test Archive

Enable this option to test a newly created zip archive for errors whan an action is completed.

  • Only works for zip archives (either created with internal zip engine or with 7-Zip).
  • Does not perform a binary comparison of files in the archive with the selected source files, it merely tests if a zip archive is corrupt or not.

  • History


History [Ctrl+H]

Table of Contents | Up: 4 - Finalize

History [Ctrl+H]

The History module maintains a list of successfully created archives of types 'Zip' and '7-Zip'.

Archive Catalogue
Notes:

Only new successfully created archives will be added to the History. To add other (older) archives to the list use 'Add Files to List'.

The settings will be checked and enforced after every successful action, or on demand, when the button 'Apply Settings Now' is pressed.

The History module stores the Archive Mode that was used to create the archive.

The History module stores the last successful archive that was created, this information is used by 'Restore Zip Archive'.

The History module does not remember any information for the 'File Operation' Action Types.

  • The History file (.abh) is saved in the same directory as the associated Profile file (.abp). This can not be changed.
  • Backups stored on removable drives will not be recorded in the History.
Enabled

If unchecked, no History information will be maintained.
This means the History file associated with the current Profile will not be (re-)created or updated: you can safely remove any *.abh files in the "Profiles" directory.

Remove backups older than N days

Backups older than N days will be removed, unless a 'minimum amount of backups to keep' is specified.
Disabled if 0.

Keep a minimum of N backups

Always keep a minimum of N backups.
Disabled if 0.

Keep a maximum of N backups

The amount of backups stored on disk will not exceed N.
Disabled if 0.

Use Recycle Bin if possible

If checked, removed backups will be placed in the Recycle Bin.
Windows can not guarantee successful use of the Recycle Bin.

Buttons:
Show List of Files

Displays the files listed by the History-module in the Status panel, and their age (in days).
No action is taken (no files will be removed).

Add Files to List

Manually adds filenames of existing archives to the History.
Use this to add filenames of archives created before the History-module was introduced to Abakt.
No Archive Mode information will be stored for these files.

Apply Settings Now

Forces an immediate check.
Files that apply will be instantly removed according to the settings.

File Catalogue

Not implemented yet.


Tools

Table of Contents | Previous: Edit Profile | Next: Preferences

Tools

  • Filter Preview
  • Restore Zip Archive
  • Group of Profiles
  • Template Editor


Filter Preview [Ctrl+Shift+F]

Table of Contents | Up: Tools | Next: Restore Zip Archive

Filter Preview [Ctrl+Shift+F]

Use Filter Preview to see which files will be included and excluded.

Build FileLists

Start building the lists according to the current filter settings and to the Options below.
You can view the lists on the Include and Exclude panels.

Strip Drive

Check this option to generate FileLists without drive information ('C:\').

Quotes

Check this option to generate FileLists where each file is surrounded with quotes (").

Scan exluded directories

If checked, Abakt's filter engine will also scan the directories that are excluded (unchecked). The result will be a larger list of excluded files on the Exluded FileList panel.

Save list of selected files

Save the selected files of the displayed FileList to a .txt file.


Restore Zip Archive [Ctrl+Shift+R]

Table of Contents | Up: Tools | Previous: Filter Preview | Next: Group of Profiles

Restore Zip Archive [Ctrl+Shift+R]

Restore previously created Zip Archives.

Zip Archive

Select or edit to open a Zip archive.
The dropdown menu displays all the archives that were stored using History.

It is not possible to open/restore .7z archives. Instead, you should use 7-Zip File Manager.

Open

Opens the Zip Archive displayed in the dropdown menu.

Destination Directory

Select or edit the directory where the files will be extracted to.

Restore Selected Files

Click this button to start extracting the selected files to the Destination Directory.


Group of Profiles [Ctrl+G]

Table of Contents | Up: Tools | Previous: Restore Zip Archive | Next: Template Editor

Group of Profiles [Ctrl+G]

Use a Group to execute a series of Profiles.

Specify (optional) custom Configuration and/or custom FilterSets that will be applied to every selected Profile.
This is a very powerful feature.

Profiles

Add and select the Profiles you want to execute as a Group.

The Profiles will be executed in the order in which they are displayed.

Custom Configuration

Adjust the selected configuration settings on this page for every selected Profile.

If a setting is selected, the setting in the Profile will be replaced with the value on this page.

If a setting is not selected, the existing setting in the Profile will not be modified.

For example, you can override "Destination.Directory" with: "C:\Burn-to-cd\" for all selected Profiles. Useful if you want to place a couple of backups into one destination directory.

Custom FilterSets

These FilterSets (selected and unselected) will be used to modify the FilterSet list of every selected Profile.

If a FilterSet in an Profile has exactly the same conditions as a FilterSet in the Template, the Template's FilterSet properties 'name', 'action' and 'enabled' will overrule these properties for the existing FilterSet.

Only the conditions of a FilterSet are used to compare, not the properties (Name, Action, Enabled).


Template Editor [Ctrl+Shift+T]

Table of Contents | Up: Tools | Previous: Group of Profiles

Template Editor [Ctrl+Shift+T]

Use an Abakt Template to adjust settings in one Abakt Profile.

Behaviour is similar to the way a Group backup works. Only the selected (checked) settings will be used.

The saved Templates (*.abt files) can be used to modify some specific settings in a Profile when Abakt is called using command line parameters.

See page Command Line (Option -T) for examples.

Custom FilterSets

This are the FilterSets that will be used to adjust the FilterSets in a Profile.

If a FilterSet in a Profile has exactly the same conditions as a FilterSet in the Template, the Template's FilterSet properties 'Name', 'Action' and 'Enabled' will overrule the properties for the existing FilterSet.
Note: Only the conditions of a FilterSet are used, not the properties (Name, Action, Enabled).

The remaining FilterSets will simply be added to the Profile's FilterSet list.

Custom Configuration

Select the Configuration settings you want to adjust when using a Template.

The values of the selected (checked) settings will be used instead of the values stored in a Profile.


Preferences [Ctrl+P]

Table of Contents | Previous: Tools | Next: Command Line

Preferences [Ctrl+P]

Set the global settings that will be stored for the current user.

  • On Startup
  • Application
  • Action
  • Logging
  • Advanced


On Startup

Table of Contents | Up: Preferences | Next: Application

On Startup
Use This Profile

Select the Profile to open when Abakt starts.

  • New
    Use 'default.abp' as a new Profile. This file can be found in the current user's "Application Data\Abakt" directory. (Windows XP: "C:\Documents and Settings\[user]\Application Data\Abakt\default.abp").
  • Previously Opened/Saved
    Use the last file that was opened or saved by Abakt.
  • Custom
    Set a custom file that should be used as a new Profile.
Restore File Associations at Next Startup

The next time Abakt is started, it will restore file associations for files with the following extensions: .ABP, .ABG, .ABT and .ABH.

If you (double-)click these files in Windows Explorer, Abakt will start and open the selected file.

These file associations will be removed from the registry when you uninstall Abakt.


Application

Table of Contents | Up: Preferences | Previous: On Startup | Next: Action

Application
Data Directory

This is the directory where your data (Profiles, Groups, Templates and Log files) will be saved.
If you modify this directory, new subdirectories will be created automaticaly.
No files will be copied when you change this directory, you will have to do that yourself.

Show Description Boxes

Turn this off if you do not need them.

Recent Files
Number of visible items

Sets the number of visible files on the various 'File | Recent Files' menus.

Show Path Information

If enabled, the full path of every file will be shown.

Language

Change the language Abakt uses. Abakt needs to restart for changes to take effect.

See Translation Status for an overview of the available languages.

Read How to translate Abakt if you want to help translating.

Preferences File

Displays the location of Abakt's global Preferences file.

You can tell Abakt to use a custom Preferences file with the command line option -I.


Action

Table of Contents | Up: Preferences | Previous: Application | Next: Logging

Action
Default Destination Directory

Used for new (Untitled) Profiles.

Temporary Directory

Specifies the directory where Abakt will save temporary files containing the list of files that should be in/excluded.
This is also the directory that ZipForge uses while updating and testing backups.
If empty, the system's default temporary directory will be used.

7-Zip Executable

Set the path to 7z.exe. Get 7-Zip from http://sourceforge.net/projects/sevenzip/

Convert filenames in @listfile to OEM

Enable to convert the filenames in the @listfile (7-Zip command line parameter) to default DOS (OEM) character set of Windows.

If disabled, the filenames will be encoded as UTF-8 by Abakt. This is 7-Zip's default setting in releases 4.33 and newer.

Confirm 'File Operation | Delete'

If enabled Abakt will show a popup asking to confirm a Delete operation.

Abakt will not ask for confirmation if it is started using command line parameters, because this would disrupt automation.


Logging

Table of Contents | Up: Preferences | Previous: Action | Next: Advanced

Logging
Action

The information that will be logged to the Action window.

Detailed Building File Lists

For every file: show IF and WHY it is included or excluded.

Enabling this option will slow down the Action and result in big log files.

Detailed Progress

Display file progress for every file in the log during Action execution.
If unchecked, only the failures are reported.
Also applies to the option Test Archive.

Enabling this option will slightly slow down the action. And it will result in a larger log file.

Save Log to '<ProfileName>.log'

Check this option if you want to automatically save the information (selected above) to a log-file (below).
The log-file '[ProfileName].log' will be saved in the Action Log Directory.

Action Log Directory

Set the directory Log files will be saved to.

Application
Save Status Messages

If enabled, the messages of the Status panel in the main window are saved to the Application Data directory of the current user.
(Windows XP: "\Documents and Settings\[user]\Application Data\Abakt\Abakt.log".)

Maximum Size (kB)

The maximum size of the Status Messages file.
When "Abakt.log" has reached 1/2 of the maximum size, the log file will be saved as "Abakt.log.old". Logging will be continued in "Abakt.log".


Advanced

Table of Contents | Up: Preferences | Previous: Logging

Advanced
Remove Non-Existing Source Directories From Profile

Enable this to remove non-existing Source Directories from a Profile when it is opened,
and from the directory tree on the Source page.

  • These directories will not be physically removed, they will simply not be displayed.
Include Empty Directories

Obsolete as a global setting since 0.9.5-beta1.
This global setting has been replaced with the per-Profile setting Include Empty Source Directories.

Create Temporary Copy if Zip Archive Exists

If enabled, Abakt makes a copy of the existing Zip archive before the Action starts.

Applies to Zip Method 'Replace'.
Disable this if you do not have much free space on the destination disk.

  • Always disabled for removable drives.
  • Be careful: If the backup fails and this option is disabled, you will lose your original copy.
Perform Safe ZipBuilder Operations

If true, instructs ZipBuilder to use a temporary file when modifying existing Zip archives. Otherwise it works directly on the original file and any error can corrupt it.

Applies to Zip Actions only.

  • Always disabled for removable drives.
  • TODO: Decide if this should replace 'Create Temporary Copy if Zip Archive Exists'.
Treat Warnings As Errors

If this setting is enabled, then, whenever a file can not be archived, the Action will abort with a fatal error.
This has an impact on several aspects of Abakt's behaviour:
- The Action will be aborted.
- The command line's exitcode will be ERROR, instead of WARNING.
- No 'Finalization' operations will be performed. In other words: the History, Test Archive, Clear Archive Attributes, etc. operations will not be performed.

Applies to Zip Actions only.

Use New UI BrowseForFolder

Disable this if you prefer the old-style BrowseForFolder windows, or if you are experiencing problems.


Command Line

Table of Contents | Previous: Preferences | Next: Format Text

Command Line

Abakt accepts command line arguments.

Useful when creating .BAT scripts to automate tasks or to start Abakt with custom settings.

Syntax

Abakt.exe [options] FILENAME

FILENAME is either an .abp or an .abg file.
- The extension is required.
- If no path information is provided, Abakt will try to find FILENAME in the subdirectories 'Profiles' or 'Groups' of the default Data directory (see Preferences).

Options

The options are case-sensitive (-m is not the same as -M).

Option
Description
-b AutoExecute
Automatically executes the Action (a Profile or a Group).
If omitted, Abakt will simply start and open the Profile or Group.
-x AutoExit
Automatically closes Abakt when the operation has finished.
- Ignored if AutoExecute is false.
-m Minimize
Minimizes Abakt during the operation.
- Ignored if AutoExecute is false.
-l Create Log File
Writes the Log to file profile-filename.log in the default Log directory (see Preferences).
This option overrides the default setting on the Preferences window.
- Ignored if AutoExecute is false.
-L Do not create a Log File
This option overrides the default setting on the Preferences window.
- Ignored if AutoExecute is false.
-o "TEXT" Use a custom 'Destination/Name Template'
Replaces the Destination's Name Template in the Profile with TEXT.
Supersedes values provided using -T.

- Ignored for Group Actions (.abg files), only works with Profiles.
- When AutoExit is false, the Profile will be openened as a modified Profile.
- Don't forget to use single quotes if desired. See Format Text for more information.

Example:
"C:\Program Files\Abakt\Abakt.exe" -o "'myNameTemplate'" "myProfile.abp"

-I "FILE" Use a custom Global Preferences File
Instructs Abakt to use FILE instead of the default global preferences file 'Abakt.ini'. Useful for debugging.
If the file does not exist it will be created.
- FILE should contain complete path information (ie. "C:\Debug\TestAbakt.prefs").
- The directory should exist, it will not be created.
-T "FILE" Use an Abakt Template (FILE should point to an existing .abt file) to override specific settings in the Profile to be executed.

If no path and/or extension information is provided, Abakt will try to find FILE in the subdirectory 'Templates' of the default Data directory (see Preferences). It is not required to append the extension '.abt'.

- When AutoExit is false, the Profile will be openened as a modified Profile.
- Ignored for Group Actions (.abg files), only works with Profiles.

Examples:

  • Abakt.exe -T DoIncrementalBackup MyDocs.abp
  • "C:\Program Files\Abakt\Abakt.exe" -T "C:\AbaktData\Profiles\DoFullBackup.abt" "C:\AbaktData\Profiles\MyDocs.abp"
-P=PRIORITY

Start Abakt using a custom priority level.

Possible values for PRIORITY:

  • 0: IDLE_PRIORITY_CLASS
  • 1: NORMAL_PRIORITY_CLASS (this is the default value)
  • 2: HIGH_PRIORITY_CLASS
  • 3: REALTIME_PRIORITY_CLASS

Example:

  • Abakt.exe -P=0 MyDocs.abp
Exit Codes

Abakt returns some useful exit codes when called from the command line. In a .BAT script they can be obtained with %ERRORLEVEL% after calling Abakt.exe.

See How to send mail when a backup has finished for an example.

If the global setting 'Treat Warnings As Errors' is enabled, the exit code will be either OK or ERROR, never WARNING.

Works with Profiles (.abp), not Groups (.abg). Does not work with 7-Zip.

Exit Codes:
  • 0: OK
  • 1: ERROR
  • 2: WARNING (OK)
Or a combination:
  • 3: ERROR+WARNING


Format Text

Table of Contents | Previous: Command Line | Next: How To ...

Format Text

Build your Format Text string according to the following rules:

Value | Meaning
(illegal) | These characters can not be used: \ / : * ? " < > |
c | Displays the date using the format given by the ShortDateFormat global variable, followed by the time using the format given by the LongTimeFormat global variable. The time is not displayed if the fractional part of the DateTime value is zero.
d | Displays the day as a number without a leading zero (1-31).
dd | Displays the day as a number with a leading zero (01-31).
ddd | Displays the day as an abbreviation (Sun-Sat) using the strings given by the ShortDayNames global variable.
dddd | Displays the day as a full name (Sunday-Saturday) using the strings given by the LongDayNames global variable.
ddddd | Displays the date using the format given by the ShortDateFormat global variable.
dddddd | Displays the date using the format given by the LongDateFormat global variable.
m | Displays the month as a number without a leading zero (1-12). If the m specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.
mm | Displays the month as a number with a leading zero (01-12). If the mm specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.
mmm | Displays the month as an abbreviation (Jan-Dec) using the strings given by the ShortMonthNames global variable.
mmmm | Displays the month as a full name (January-December) using the strings given by the LongMonthNames global variable.
yy | Displays the year as a two-digit number (00-99).
yyyy | Displays the year as a four-digit number (0000-9999).
h | Displays the hour without a leading zero (0-23).
hh | Displays the hour with a leading zero (00-23).
n | Displays the minute without a leading zero (0-59).
nn | Displays the minute with a leading zero (00-59).
s | Displays the second without a leading zero (0-59).
ss | Displays the second with a leading zero (00-59).
t | Displays the time using the format given by the ShortTimeFormat global variable.
tt | Displays the time using the format given by the LongTimeFormat global variable.
'text' | Characters enclosed in single quotes are displayed as is, and do not affect formatting.
 | [Source: Borland Help File]


How To ...

Table of Contents | Previous: Format Text | Next: FAQ

How To ...

Several examples of how to use Abakt.

  • Create your first backup
  • Include only one file in a directory
  • Use the Windows Task Scheduler
  • Send mail when a backup has finished
  • Transfer backups to an FTP server.
  • Create Zip files larger than 4 GB
  • Create a multi-volume archive using 7-Zip


Create your first backup

Table of Contents | Up: How To ... | Next: Include only one file in a directory

Create your first backup

A simple step-by-step guide to help you make your first backup.

Let's suppose you want to make a ZIP-backup of the "My Documents" folder.
The following steps describe how to create and execute a Profile to do just that.

  1. Start Abakt and create a new Profile. [File | New Profile].

  2. Go to page Source [F6]:
    Click the button 'Add'.
    Browse to "My Documents" and click OK. Abakt will display a folder like "C:\Documents and Settings\erik\My Documents" and its subfolders.

    All files in unselected directories will be ignored when executing an Action.

  3. [Optionally] On the Files-panel: Right-click a file, a popup menu appears that will help you create new FilterSets.
    You can review/edit the FilterSets on page Filters [F7].

  4. Go to page Action/Action Type [F8]:
    Select the desired Action: "Zip".

  5. Go to page Action/Action Type Settings [F9]:
    Review the settings for the selected Action ("Zip"). The default settings should be fine.

  6. Go to page Destination [F10]:
    Click the button 'Directory' and select an existing directory or create a new one.

  7. To create the backup click the button 'Execute Action'.


Include only one file in a directory

Table of Contents | Up: How To ... | Previous: Create your first backup | Next: Use the Windows Task Scheduler

Include only one file in a directory

Rephrased: Exclude all files in a directory, except one (or more) specific file(s).

Following is an example of how to exclude all files in "C:\Test\", except the file "C:\Test\keep-me.txt".

  1. The directory "C:\Test\" must be selected (yellow checkbox).

    Unselected directories will be ignored throughout the rest of the filter process.

  2. Right-click any file in the Files panel: A popup-menu appears.

  3. Select 'Exclude/All Files in This Dir'.
    At this point all files in the directory "C:\Test\" are excluded.

  4. Next, right-click the file you want to include ("C:\Test\keep-me.txt"), and choose 'Include (Always)/This File'.

  5. That's it!
    At this point all files in the directory "C:\Test\" are excluded except for "keep-me.txt".
    You can repeat step 2 for other files you want to force-include.


Use the Windows Task Scheduler

Table of Contents | Up: How To ... | Previous: Include only one file in a directory | Next: Send mail when a backup has finished

Use the Windows Task Scheduler

You can use command line options to feed the Windows Task Scheduler.

  1. Create a Windows shortcut-file to Abakt with a Target like this:

    "C:\Program Files\Abakt\Abakt.exe" -b "C:\Profiles\MyProfile.abp"

    Or like this:

    "C:\Program Files\Abakt\Abakt.exe" -b -x -m "MyGroupOfProfiles.abg"

  2. Next, instruct the Windows Task Scheduler to call the shortcut you created.

Perhaps a better way is to create and call a .BAT file instead of a shortcut.


Send mail when a backup has finished

Table of Contents | Up: How To ... | Previous: Use the Windows Task Scheduler | Next: Transfer backups to an FTP server.

Send mail when a backup has finished

Following is an example of a .BAT script that calls Abakt and sends an e-mail with useful information.
You should probably modify the script a little so that it works on your system.

The script uses blat, a command line utility to send mail. Download blat.zip and extract it to "C:\Program Files\blat\".

Example
set BLAT="C:\Program Files\blat\smtp\blat.exe"
set ABAKT="C:\Program Files\Abakt.exe"
set PROFILE=MyProfile
set HOME=C:\Documents and Settings\erik
set LOGFILE="%HOME%\Application Data\Abakt\Log\%PROFILE%.log"
set EMAIL=myName@myProvider.net

@rem == Prepare blat:
%BLAT% -install smtp.myprovider.net %EMAIL%

@rem == Call Abakt:
%ABAKT% -b -x -l -m "%PROFILE%.abp"

goto result%ERRORLEVEL%
:result0
    @rem OK (0x00)
    %BLAT% %LOGFILE% -s "%PROFILE% Ok" -to %EMAIL%
    @goto end
:result2
    @rem OK+WARNING (0x02)
    %BLAT% %LOGFILE% -s "%PROFILE% Ok + Warnings" -to %EMAIL%
    @goto end
:result1
    @rem ERROR (0x01)
:result3
    @rem ERROR+WARNING (0x03)
    %BLAT% %LOGFILE% -s "%PROFILE% Failed!" -to %EMAIL%
    @goto end

:end


Transfer backups to an FTP server

Table of Contents | Up: How To ... | Previous: Send mail when a backup has finished | Next: Create Zip files larger than 4 GB

Transfer backups to an FTP server

Two simple scripts that perform a backup and transfer the backups to an ftp server. This is a simple example that shows you how to use the FTP command provided by Windows.

Create the following two files and modify the example values that are used in the files. You can run backupdata.bat manually or add it to the Windows Task Scheduler.

backupdata.bat

"C:\Program Files\Abakt\Abakt.exe" -b -x -m MyBackups.abg
FTP -i -s:ftpscript.txt

ftpscript.txt

open ftp.remoteserver.com
username
password
cd RemoteBackupDir
lcd "D:\LocalBackupDir"
mput *.*
bye

For more advanced file transfer options (like SFTP) you can use one of Putty's command line tools. See http://www.chiark.greenend.org.uk/~sgtatham/putty/.

The scripts above are provided by Bas.


Create Zip files larger than 4 GB

Table of Contents | Up: How To ... | Previous: Transfer backups to an FTP server. | Next: Create a multi-volume archive using 7-Zip

Create Zip files larger than 4 GB

The original PKZIP standard does not allow .ZIP files to be larger than 4 GB.

Try using 7-Zip to create .zip or .7z archives larger than 4 GB.
From 7-Zip's documentation: "7-Zip supports Zip64 extension of ZIP format". I think this is done automatically. Using 7-Zip 4.32 I managed to create .ZIP archives larger than 4 GB without problems.

These archives can not be extracted with Abakt's built-in zip-library. Use 7-Zip Manager, IZArc or WinZip instead.

Note: The Windows 95/98(SE)/ME operating systems do not support files greater than 4 GB at all.


Create a multi-volume archive using 7-Zip

Table of Contents | Up: How To ... | Previous: Create Zip files larger than 4 GB

Create a multi-volume archive using 7-Zip

Use 7-Zip's command line switch -v (see 7-Zip's manual for more information).

Example, on page F9 / 7-Zip use this command line:

$C $T $N -mx=0 $P $W $L -v1g
This will create volumes of 1 GB.


Frequently Asked Questions

Table of Contents | Previous: How To ...

Frequently Asked Questions

Answers to some Frequently Asked Questions.

If you have some additional information you would like to share with other users of Abakt, please let me know.

  • 'File lock violation'
  • 'Incorrect wildcard in listfile'


File lock violation

Table of Contents | Up: FAQ | Next: 'Incorrect wildcard in listfile'

File lock violation

I read a message like this in Abakt's log when performing a Zip Action:

Tf_Action::ZipBuilderMessage: ErrCode=0x21 (33), Message="Warning: File lock violation: C:\Documents and Settings\erik\Local Settings\Application Data\Microsoft\Outlook\Microsoft\Outlook\mailbox.pst"

This error message is actually from Windows, ZipBuilder just passes it on. Here is the actual message:

ERROR_LOCK_VIOLATION 33: "The process cannot access the file because another process has locked a portion of the file."

You can use a tool like Unlocker (http://ccollomb.free.fr/unlocker/ ) to find out which program has a lock on the file mailbox.pst.

Finding out which program is locking a file does not make it possible for Abakt to archive this file, it merely helps you finding the cause for the error message.


Incorrect wildcard in listfile

Table of Contents | Up: FAQ | Previous: 'File lock violation'

Incorrect wildcard in listfile

I read a message like this in Abakt's log when performing a 7-Zip Action:

Error: Incorrect wildcard in listfile

This error message means that you are using a 7-Zip release newer than 4.33. Since this release 7-Zip expects listfiles to be formatted as UTF-8 instead of OEM.

You can tell Abakt to format listfiles as UTF-8 by disabling 'Preferences/Action/Convert filenames in @listfile to OEM'.


INDEX

Table of Contents

INDEX
  • Abakt
    • Requirements
    • Setup
    • Installation
    • Uninstallation
    • Donations
    • License
  • Filters
    • FilterSets
  • Tools
    • Filter Preview
    • Restore Zip Archive
    • Group of Profiles
    • Template Editor


Abakt Manual

Author : Erik Dienske

Internet : http://www.xs4all.nl/~edienske/abakt/

E-mail : See the 'Help/About' window in the application

Last Modified : 5-November-2006

Abakt Logo Abakt Manual
Table of Contents
  • Abakt?
    • Introduction
    • Requirements
    • Setup
    • Donate
    • License
  • Edit Profile
    • 1 - Source
    • 2 - Filters
    • 3 - Action
      • Action Type
      • Action Type Settings
        • Zip
        • 7-Zip
        • File Operation
      • Destination
    • 4 - Finalize
      • History
  • Tools
    • Filter Preview
    • Restore Zip Archive
    • Group of Profiles
    • Template Editor
  • Preferences
    • On Startup
    • Application
    • Action
    • Logging
    • Advanced
  • Command Line
  • Format Text
  • How To ...
    • Create your first backup
    • Include only one file in a directory
    • Use the Windows Task Scheduler
    • Send mail when a backup has finished
    • Transfer backups to an FTP server.
    • Create Zip files larger than 4 GB
    • Create a multi-volume archive using 7-Zip
  • FAQ
    • 'File lock violation'
    • 'Incorrect wildcard in listfile'
  • INDEX